diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 0dae10083..dd3b77653 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1547,6 +1205,372 @@ public class RenderGlobal
         }
     }
 
+    public void drawTileSelectionBox(ICamera camera, TilePosc tilePos, float partialTick) {
+        if (GameSettings.IMMERSIVE_MODE.drawOutline() && GameSettings.BLOCK_OUTLINE_WIDTH.value > 0.01f && !(this.mc.currentScreen instanceof ScreenModelViewer)) {
+            GLRenderer.pushFrame();
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            float w = GameSettings.BLOCK_OUTLINE_WIDTH.get();
+            GLRenderer.setColor4f(0.0F, 0.0F, 0.0F, 0.35f + w * 0.3f);
+            GLRenderer.setLineWidth(org.joml.Math.max(4.0f * w * 2.0f, 1.0f));
+            GLRenderer.setShader(Shaders.LINES);
+            GLRenderer.setDepthMask(false);
+            double offsetX = camera.getX(partialTick);
+            double offsetY = camera.getY(partialTick);
+            double offsetZ = camera.getZ(partialTick);
+
+            drawTileSelectionBoxRaw(camera, tilePos, offsetX, offsetY, offsetZ);
+            
+            GLRenderer.popFrame();
+        }
+    }
+
+    private void drawTileSelectionBoxRaw(ICamera camera, TilePosc tilePos, double offsetX, double offsetY, double offsetZ) {
+        float expand = 0.002F;
+        Block<?> block = this.world.getBlockType(tilePos);
+        BoundingVolume volume = block.getBoundingVolume(this.world, tilePos);
+        if (volume != null) {
+            drawOutlinedVolume(volume, tilePos.x() - offsetX, tilePos.y() - offsetY, tilePos.z() - offsetZ, expand);
+        } else {
+            AABBd selectionBB = MathHelper.aabbGrow(block.getSelectionAABB(this.world, tilePos), expand, expand, expand, new AABBd());
+            selectionBB.translate(-offsetX, -offsetY, -offsetZ);
+            drawOutlinedBoundingBox(selectionBB);
+        }
+        if (GameSettings.VIEW_SUPPORT_MODE.value) {
+            TessellatorGeneral t = GLRenderer.getTessellator();
+
+            double x = tilePos.x() - offsetX;
+            double y = tilePos.y() - offsetY;
+            double z = tilePos.z() - offsetZ;
+
+            double oMin = -0.01;
+            double oMax = 1.01;
+
+            ISupport sBottom = block.getSupport(this.world, tilePos, Side.BOTTOM);
+            ISupport sTop = block.getSupport(this.world, tilePos, Side.TOP);
+            ISupport sNorth = block.getSupport(this.world, tilePos, Side.NORTH);
+            ISupport sSouth = block.getSupport(this.world, tilePos, Side.SOUTH);
+            ISupport sWest = block.getSupport(this.world, tilePos, Side.WEST);
+            ISupport sEast = block.getSupport(this.world, tilePos, Side.EAST);
+
+            t.startDrawingQuads();
+
+            {// Top
+                if (sTop.canSupport(PartialSupport.INSTANCE.center(), Side.BOTTOM)) {
+                    t.setColor4f(0f, 1f, 0f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0f, 0.25f);
+                }
+                t.addVertex(x + oMin + 0.25, y + oMax, z + oMin + 0.25);
+                t.addVertex(x + oMin + 0.25, y + oMax, z + oMax - 0.25);
+                t.addVertex(x + oMax - 0.25, y + oMax, z + oMax - 0.25);
+                t.addVertex(x + oMax - 0.25, y + oMax, z + oMin + 0.25);
+
+                if (sTop.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM)) {
+                    t.setColor4f(0.5f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMax, z + oMin);
+                t.addVertex(x + oMin + 0.25, y + oMax, z + oMin + 0.25);
+                t.addVertex(x + oMax - 0.25, y + oMax, z + oMin + 0.25);
+                t.addVertex(x + oMax, y + oMax, z + oMin);
+
+                if (sTop.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM)) {
+                    t.setColor4f(0f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMax, z + oMax);
+                t.addVertex(x + oMax, y + oMax, z + oMax);
+                t.addVertex(x + oMax - 0.25, y + oMax, z + oMax - 0.25);
+                t.addVertex(x + oMin + 0.25, y + oMax, z + oMax - 0.25);
+
+                if (sTop.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMax, z + oMin);
+                t.addVertex(x + oMin, y + oMax, z + oMax);
+                t.addVertex(x + oMin + 0.25, y + oMax, z + oMax - 0.25);
+                t.addVertex(x + oMin + 0.25, y + oMax, z + oMin + 0.25);
+
+                if (sTop.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMax, y + oMax, z + oMin);
+                t.addVertex(x + oMax - 0.25, y + oMax, z + oMin + 0.25);
+                t.addVertex(x + oMax - 0.25, y + oMax, z + oMax - 0.25);
+                t.addVertex(x + oMax, y + oMax, z + oMax);
+            }
+
+            {// Bottom
+                if (sBottom.canSupport(PartialSupport.INSTANCE.center(), Side.TOP)) {
+                    t.setColor4f(0f, 1f, 0f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0f, 0.25f);
+                }
+                t.addVertex(x + oMin + 0.25, y + oMin, z + oMin + 0.25);
+                t.addVertex(x + oMax - 0.25, y + oMin, z + oMin + 0.25);
+                t.addVertex(x + oMax - 0.25, y + oMin, z + oMax - 0.25);
+                t.addVertex(x + oMin + 0.25, y + oMin, z + oMax - 0.25);
+
+                if (sBottom.canSupport(PartialSupport.INSTANCE.up(), Side.TOP)) {
+                    t.setColor4f(0.5f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMin + 0.25, y + oMin, z + oMax - 0.25);
+                t.addVertex(x + oMax - 0.25, y + oMin, z + oMax - 0.25);
+                t.addVertex(x + oMax, y + oMin, z + oMax);
+                t.addVertex(x + oMin, y + oMin, z + oMax);
+
+                if (sBottom.canSupport(PartialSupport.INSTANCE.down(), Side.TOP)) {
+                    t.setColor4f(0f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMin + 0.25, y + oMin, z + oMin + 0.25);
+                t.addVertex(x + oMin, y + oMin, z + oMin);
+                t.addVertex(x + oMax, y + oMin, z + oMin);
+                t.addVertex(x + oMax - 0.25, y + oMin, z + oMin + 0.25);
+
+                if (sBottom.canSupport(PartialSupport.INSTANCE.left(), Side.TOP)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMax, y + oMin, z + oMin);
+                t.addVertex(x + oMax, y + oMin, z + oMax);
+                t.addVertex(x + oMax - 0.25, y + oMin, z + oMax - 0.25);
+                t.addVertex(x + oMax - 0.25, y + oMin, z + oMin + 0.25);
+
+                if (sBottom.canSupport(PartialSupport.INSTANCE.right(), Side.TOP)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMin, z + oMin);
+                t.addVertex(x + oMin + 0.25, y + oMin, z + oMin + 0.25);
+                t.addVertex(x + oMin + 0.25, y + oMin, z + oMax - 0.25);
+                t.addVertex(x + oMin, y + oMin, z + oMax);
+            }
+
+            {// North
+                if (sNorth.canSupport(PartialSupport.INSTANCE.center(), Side.SOUTH)) {
+                    t.setColor4f(0f, 1f, 0f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0f, 0.25f);
+                }
+                t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMin);
+                t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMin);
+                t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMin);
+                t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMin);
+
+                if (sNorth.canSupport(PartialSupport.INSTANCE.up(), Side.SOUTH)) {
+                    t.setColor4f(0f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMax, z + oMin);
+                t.addVertex(x + oMax, y + oMax, z + oMin);
+                t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMin);
+                t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMin);
+
+                if (sNorth.canSupport(PartialSupport.INSTANCE.down(), Side.SOUTH)) {
+                    t.setColor4f(0f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMin);
+                t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMin);
+                t.addVertex(x + oMax, y + oMin, z + oMin);
+                t.addVertex(x + oMin, y + oMin, z + oMin);
+
+                if (sNorth.canSupport(PartialSupport.INSTANCE.right(), Side.SOUTH)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMax, z + oMin);
+                t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMin);
+                t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMin);
+                t.addVertex(x + oMin, y + oMin, z + oMin);
+
+                if (sNorth.canSupport(PartialSupport.INSTANCE.left(), Side.SOUTH)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMax, y + oMax, z + oMin);
+                t.addVertex(x + oMax, y + oMin, z + oMin);
+                t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMin);
+                t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMin);
+            }
+
+            {// South
+                if (sSouth.canSupport(PartialSupport.INSTANCE.center(), Side.NORTH)) {
+                    t.setColor4f(0f, 1f, 0f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0f, 0.25f);
+                }
+                t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMax);
+                t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMax);
+                t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMax);
+                t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMax);
+
+                if (sSouth.canSupport(PartialSupport.INSTANCE.up(), Side.NORTH)) {
+                    t.setColor4f(0f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMax, z + oMax);
+                t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMax);
+                t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMax);
+                t.addVertex(x + oMax, y + oMax, z + oMax);
+
+                if (sSouth.canSupport(PartialSupport.INSTANCE.down(), Side.NORTH)) {
+                    t.setColor4f(0f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMax);
+                t.addVertex(x + oMin, y + oMin, z + oMax);
+                t.addVertex(x + oMax, y + oMin, z + oMax);
+                t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMax);
+
+                if (sSouth.canSupport(PartialSupport.INSTANCE.right(), Side.NORTH)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMax, y + oMax, z + oMax);
+                t.addVertex(x + oMax - 0.25, y + oMax - 0.25, z + oMax);
+                t.addVertex(x + oMax - 0.25, y + oMin + 0.25, z + oMax);
+                t.addVertex(x + oMax, y + oMin, z + oMax);
+
+                if (sSouth.canSupport(PartialSupport.INSTANCE.left(), Side.NORTH)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMax, z + oMax);
+                t.addVertex(x + oMin, y + oMin, z + oMax);
+                t.addVertex(x + oMin + 0.25, y + oMin + 0.25, z + oMax);
+                t.addVertex(x + oMin + 0.25, y + oMax - 0.25, z + oMax);
+            }
+
+            {// West
+                if (sWest.canSupport(PartialSupport.INSTANCE.center(), Side.EAST)) {
+                    t.setColor4f(0f, 1f, 0f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMax - 0.25, z + oMin + 0.25);
+                t.addVertex(x + oMin, y + oMin + 0.25, z + oMin + 0.25);
+                t.addVertex(x + oMin, y + oMin + 0.25, z + oMax - 0.25);
+                t.addVertex(x + oMin, y + oMax - 0.25, z + oMax - 0.25);
+
+                if (sWest.canSupport(PartialSupport.INSTANCE.up(), Side.EAST)) {
+                    t.setColor4f(0f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMax, z + oMin);
+                t.addVertex(x + oMin, y + oMax - 0.25, z + oMin + 0.25);
+                t.addVertex(x + oMin, y + oMax - 0.25, z + oMax - 0.25);
+                t.addVertex(x + oMin, y + oMax, z + oMax);
+
+                if (sWest.canSupport(PartialSupport.INSTANCE.down(), Side.EAST)) {
+                    t.setColor4f(0f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMin, z + oMin);
+                t.addVertex(x + oMin, y + oMin, z + oMax);
+                t.addVertex(x + oMin, y + oMin + 0.25, z + oMax - 0.25);
+                t.addVertex(x + oMin, y + oMin + 0.25, z + oMin + 0.25);
+
+                if (sWest.canSupport(PartialSupport.INSTANCE.left(), Side.EAST)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMax, z + oMin);
+                t.addVertex(x + oMin, y + oMin, z + oMin);
+                t.addVertex(x + oMin, y + oMin + 0.25, z + oMin + 0.25);
+                t.addVertex(x + oMin, y + oMax - 0.25, z + oMin + 0.25);
+
+                if (sWest.canSupport(PartialSupport.INSTANCE.right(), Side.EAST)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMin, y + oMax - 0.25, z + oMax - 0.25);
+                t.addVertex(x + oMin, y + oMin + 0.25, z + oMax - 0.25);
+                t.addVertex(x + oMin, y + oMin, z + oMax);
+                t.addVertex(x + oMin, y + oMax, z + oMax);
+            }
+
+            {// East
+                if (sEast.canSupport(PartialSupport.INSTANCE.center(), Side.WEST)) {
+                    t.setColor4f(0f, 1f, 0f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0f, 0.25f);
+                }
+                t.addVertex(x + oMax, y + oMax - 0.25, z + oMin + 0.25);
+                t.addVertex(x + oMax, y + oMax - 0.25, z + oMax - 0.25);
+                t.addVertex(x + oMax, y + oMin + 0.25, z + oMax - 0.25);
+                t.addVertex(x + oMax, y + oMin + 0.25, z + oMin + 0.25);
+
+                if (sEast.canSupport(PartialSupport.INSTANCE.up(), Side.WEST)) {
+                    t.setColor4f(0f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMax, y + oMax, z + oMin);
+                t.addVertex(x + oMax, y + oMax, z + oMax);
+                t.addVertex(x + oMax, y + oMax - 0.25, z + oMax - 0.25);
+                t.addVertex(x + oMax, y + oMax - 0.25, z + oMin + 0.25);
+
+                if (sEast.canSupport(PartialSupport.INSTANCE.down(), Side.WEST)) {
+                    t.setColor4f(0f, 1f, 0.5f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 0.5f, 0.25f);
+                }
+                t.addVertex(x + oMax, y + oMin, z + oMin);
+                t.addVertex(x + oMax, y + oMin + 0.25, z + oMin + 0.25);
+                t.addVertex(x + oMax, y + oMin + 0.25, z + oMax - 0.25);
+                t.addVertex(x + oMax, y + oMin, z + oMax);
+
+                if (sEast.canSupport(PartialSupport.INSTANCE.left(), Side.WEST)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMax, y + oMax - 0.25, z + oMax - 0.25);
+                t.addVertex(x + oMax, y + oMax, z + oMax);
+                t.addVertex(x + oMax, y + oMin, z + oMax);
+                t.addVertex(x + oMax, y + oMin + 0.25, z + oMax - 0.25);
+
+                if (sEast.canSupport(PartialSupport.INSTANCE.right(), Side.WEST)) {
+                    t.setColor4f(0f, 1f, 1f, 0.25f);
+                } else {
+                    t.setColor4f(1f, 0f, 1f, 0.25f);
+                }
+                t.addVertex(x + oMax, y + oMax, z + oMin);
+                t.addVertex(x + oMax, y + oMax - 0.25, z + oMin + 0.25);
+                t.addVertex(x + oMax, y + oMin + 0.25, z + oMin + 0.25);
+                t.addVertex(x + oMax, y + oMin, z + oMin);
+            }
+
+            t.draw();
+        }
+    }
+
     public void drawDebugEntityOutlines(ICamera camera, float partialTicks) {
         GLRenderer.pushFrame();
         GLRenderer.setShader(Shaders.LINES);
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index cc17ccdd1..66736be6b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -49,6 +49,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.debug.Debug;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Time;
 import net.minecraft.core.util.phys.HitResult;
@@ -200,6 +201,21 @@ public class WorldRenderer {
             this.mc.objectMouseOver = new HitResult.Entity(this.pointedEntity);
         }
 
+        this.mc.canBridge = false;
+        if (this.mc.objectMouseOver != null) return;
+
+        if (!GameSettings.EASY_BRIDGE.value) return;
+        if (!this.mc.thePlayer.onGround) return;
+        if (Direction.getLockable(this.mc.thePlayer) != Direction.DOWN) return;
+        if (this.mc.thePlayer.inventory.getCurrentItem() == null) return;
+
+        this.mc.bridgePos.set(
+            MathHelper.floor(this.mc.thePlayer.x),
+            MathHelper.floor(this.mc.thePlayer.y - this.mc.thePlayer.heightOffset - 0.25),
+            MathHelper.floor(this.mc.thePlayer.z)
+        );
+
+        this.mc.canBridge = this.mc.thePlayer.world.canPlaceInsideBlock(this.mc.bridgePos);
     }
 
     private float getFOVModifier(float partialTick, boolean isModifiedByFOV) {
@@ -684,6 +700,8 @@ public class WorldRenderer {
             }
             renderGlobal.drawSelectionBox(this.mc.activeCamera, this.mc.objectMouseOver, partialTicks);
 //            glEnable(GL_ALPHA_TEST);
+        } else if (this.mc.canBridge) {
+            renderGlobal.drawTileSelectionBox(this.mc.activeCamera, this.mc.bridgePos, partialTicks);
         }
 
         Debug.change("debugoverlays");
diff --git a/game/client/src/main/java/net/minecraft/client/sound/MusicCategory.java b/game/client/src/main/java/net/minecraft/client/sound/MusicCategory.java
new file mode 100644
index 000000000..1f47092b9
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/sound/MusicCategory.java
@@ -0,0 +1,19 @@
+package net.minecraft.client.sound;
+
+import org.jetbrains.annotations.NotNull;
+
+public enum MusicCategory {
+
+    OVERWORLD("overworld"),
+    UNDERGROUND("underground");
+
+    public final String namespace;
+
+    MusicCategory(@NotNull String category){
+        this.namespace = category;
+    }
+
+    public String getNamespace() {
+        return this.namespace;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/sound/MusicCategoryManager.java b/game/client/src/main/java/net/minecraft/client/sound/MusicCategoryManager.java
new file mode 100644
index 000000000..3ff45d21d
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/sound/MusicCategoryManager.java
@@ -0,0 +1,35 @@
+package net.minecraft.client.sound;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.HashMap;
+import java.util.Map;
+
+public class MusicCategoryManager {
+
+    private static final HashMap<MusicCategory, MusicCondition> MUSIC_CATEGORIES = new HashMap<>();
+
+    static {
+        register(MusicCategory.OVERWORLD, (World::canBlockSeeSky));
+        register(MusicCategory.UNDERGROUND, (world, pos) -> (!world.canBlockSeeSky(pos)) && pos.y <= world.getWorldType().getOceanY());
+    }
+
+    public static void register(MusicCategory category, MusicCondition condition){
+        MUSIC_CATEGORIES.put(category, condition);
+    }
+    
+    public static @Nullable MusicCategory resolve(@NotNull Player player){
+        @NotNull World world = player.world;
+        TilePos pos = new TilePos(player.x, player.y, player.z);
+
+        for (Map.Entry<MusicCategory, MusicCondition> entry : MUSIC_CATEGORIES.entrySet()) {
+            if (entry.getValue().test(world, pos)) return entry.getKey();
+        }
+        return null;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/sound/MusicCondition.java b/game/client/src/main/java/net/minecraft/client/sound/MusicCondition.java
new file mode 100644
index 000000000..4d9ebfec9
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/sound/MusicCondition.java
@@ -0,0 +1,9 @@
+package net.minecraft.client.sound;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+
+public interface MusicCondition {
+    boolean test(@NotNull World world, @NotNull TilePos pos);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java b/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
index 3170cea2a..0ae61e2e2 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.sound;
 
 import java.net.URL;
+import java.util.ArrayList;
+import java.util.List;
 import java.util.Random;
 import java.util.concurrent.locks.Lock;
 import java.util.concurrent.locks.ReentrantLock;
@@ -30,10 +32,13 @@ public class SoundEngine
 	public static final String BG_MUSIC = "BgMusic";
 	public static final String STREAMING = "Streaming";
 
+	private final int AMBIENCE_TICKS = 6000;
+
 	private int idCounter;
 	private final Random random;
 	private Minecraft mc;
 	public int ticksBeforeMusic;
+	public int ticksBeforeAmbience;
 	private boolean muted = false;
 
 	public SoundEngine() {
@@ -45,6 +50,10 @@ public class SoundEngine
 		this.ticksBeforeMusic = GameSettings.MUSIC_FREQUENCY.value.interval == 0 ? 0 : this.random.nextInt(GameSettings.MUSIC_FREQUENCY.value.interval);
 	}
 
+	public void resetAmbienceTicks() {
+		this.ticksBeforeAmbience = this.random.nextInt(AMBIENCE_TICKS);
+	}
+
 	public void destroy() {
 		try {
 			lock.lock();
@@ -139,17 +148,14 @@ public class SoundEngine
 			}
 
 			if (!soundSystem.playing(BG_MUSIC) && !soundSystem.playing(STREAMING)) {
-				final @Nullable SoundEvent event = SoundRepository.SOUNDS.getRandomSoundFromCategory("music.");
+				final @Nullable SoundEvent event = getMusicTrack();
 				if (event == null) {
 					return;
 				}
 
 				final @Nullable SoundEntry entry = event.getRandomEntry();
 				if (entry != null) {
-					soundSystem.backgroundMusic(BG_MUSIC, entry.getURL(), entry.name, false);
-					soundSystem.setPitch(BG_MUSIC, entry.pitch);
-					soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC) * entry.volume);
-					soundSystem.play(BG_MUSIC);
+					playBackgroundSound(entry);
 				}
 			}
 		} catch (Exception e) {
@@ -166,34 +172,11 @@ public class SoundEngine
 				return;
 			}
 
-			if (!soundSystem.playing(BG_MUSIC) && !soundSystem.playing(STREAMING)) {
-				if (this.ticksBeforeMusic > 0) {
-					this.ticksBeforeMusic--;
-					return;
-				}
+			if (soundSystem.playing(BG_MUSIC) || soundSystem.playing(STREAMING)) return;
+
+			this.tickCaveAmbience();
+			this.tickBackgroundMusic();
 
-				// TODO a more sane way of grouping music pools with our new system
-				final SoundEvent event;
-				if (this.mc != null && this.mc.thePlayer != null && !this.mc.thePlayer.world.canBlockSeeTheSky(MathHelper.floor(this.mc.thePlayer.x), MathHelper.floor(this.mc.thePlayer.y), MathHelper.floor(this.mc.thePlayer.z))) {
-					event = SoundRepository.SOUNDS.getSoundEvent("ambient.cave");
-				} else {
-					event = SoundRepository.SOUNDS.getRandomSoundFromCategory("music.");
-				}
-				if (event == null) return;
-				final SoundEntry entry = event.getRandomEntry();
-				if (entry != null) {
-					this.resetMusicTicks();
-					this.ticksBeforeMusic += GameSettings.MUSIC_FREQUENCY.value.interval;
-					soundSystem.backgroundMusic(BG_MUSIC, entry.getURL(), entry.name, false);
-					soundSystem.setPitch(BG_MUSIC, entry.pitch);
-					soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC) * entry.volume);
-					soundSystem.play(BG_MUSIC);
-
-					if (GameSettings.MUSIC_TOASTS.value && entry.title != null) {
-						mc.guiToasts.addToast(new MusicToast(entry.title, entry.author));
-					}
-				}
-			}
 		} catch (Exception e) {
 			LOGGER.error("Unexpected exception while ticking sound engine!", e);
 		} finally {
@@ -201,6 +184,101 @@ public class SoundEngine
 		}
     }
 
+	private void tickBackgroundMusic() {
+		if (this.mc == null || this.mc.thePlayer == null) {
+			return;
+		}
+
+		if (this.ticksBeforeMusic > 0) {
+			this.ticksBeforeMusic--;
+			return;
+		}
+
+		MusicCategory category = MusicCategoryManager.resolve(this.mc.thePlayer);
+
+		if(category == null) return;
+
+		SoundEvent event = this.getMusicTrackFromCategory(category);
+
+		if(event == null) return;
+
+		SoundEntry entry = event.getRandomEntry();
+		if(entry == null) return;
+
+		this.resetMusicTicks();
+		this.ticksBeforeMusic += GameSettings.MUSIC_FREQUENCY.value.interval;
+		this.playBackgroundSound(entry);
+		if (GameSettings.MUSIC_TOASTS.value && entry.title != null) {
+			mc.guiToasts.addToast(new MusicToast(entry.title, entry.author));
+		}
+	}
+
+	private void tickCaveAmbience() {
+		if (this.mc == null || this.mc.thePlayer == null) {
+			return;
+		}
+
+		if (this.mc.thePlayer.world.canBlockSeeTheSky(
+				MathHelper.floor(this.mc.thePlayer.x),
+				MathHelper.floor(this.mc.thePlayer.y),
+				MathHelper.floor(this.mc.thePlayer.z))
+		) {
+			return;
+		}
+
+		if (this.ticksBeforeAmbience > 0) {
+			this.ticksBeforeAmbience--;
+			return;
+		}
+
+		SoundEvent event = SoundRepository.SOUNDS.getSoundEvent("ambient.cave");
+		if(event == null) return;
+
+		SoundEntry entry = event.getRandomEntry();
+		if(entry == null) return;
+
+		this.resetAmbienceTicks();
+		this.ticksBeforeAmbience += AMBIENCE_TICKS;
+		this.playBackgroundSound(entry);
+	}
+
+	private void playBackgroundSound(SoundEntry entry) {
+		soundSystem.backgroundMusic(BG_MUSIC, entry.getURL(), entry.name, false);
+		soundSystem.setPitch(BG_MUSIC, entry.pitch);
+		soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC) * entry.volume);
+		soundSystem.play(BG_MUSIC);
+	}
+
+	public @Nullable SoundEvent getMusicTrack() {
+		List<SoundEvent> eligible = new ArrayList<>();
+
+		for(Soundtrack soundtrack : GameSettings.SELECTED_SOUNDTRACK.value.soundtracks) {
+			SoundEvent event = SoundRepository.SOUNDS.getRandomSoundFromCategory(soundtrack.getPath());
+			if(event != null) {
+				eligible.add(event);
+			}
+		}
+
+		if(eligible.size() == 0) return null;
+
+		return eligible.get(random.nextInt(eligible.size()));
+	}
+
+	public @Nullable SoundEvent getMusicTrackFromCategory(MusicCategory category) {
+		List<SoundEvent> eligible = new ArrayList<>();
+
+		for(Soundtrack soundtrack : GameSettings.SELECTED_SOUNDTRACK.value.soundtracks) {
+			SoundEvent event = SoundRepository.SOUNDS.getSoundEvent(soundtrack.getSoundEventPath(category));
+			if(event != null) {
+				eligible.add(event);
+			}
+		}
+
+		if(eligible.size() == 0) return null;
+
+		return eligible.get(random.nextInt(eligible.size()));
+	}
+
 	public void playSound(final String name, final SoundCategory category, final float volume, final float pitch) {
 		playSound(SoundRepository.SOUNDS.getSoundEntry(name), category, volume, pitch);
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/sound/Soundtrack.java b/game/client/src/main/java/net/minecraft/client/sound/Soundtrack.java
new file mode 100644
index 000000000..c77ce6724
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/sound/Soundtrack.java
@@ -0,0 +1,23 @@
+package net.minecraft.client.sound;
+
+import org.jetbrains.annotations.NotNull;
+
+public enum Soundtrack {
+
+    MINECRAFT("original"),
+    BETTER_THAN_ADVENTURE("bta");
+
+    public final String name;
+
+    Soundtrack(@NotNull String category){
+        this.name = category;
+    }
+
+    public String getPath() {
+        return "music.%s".formatted(name);
+    }
+
+    public String getSoundEventPath(@NotNull MusicCategory category) {
+        return "music.%s.%s".formatted(name, category.namespace);
+    }
+}
